C - Longtail Hedgehog
Codeforces Round #338 (Div. 2)
This Christmas Santa gave Masha a magic picture and a pencil. The picture consists of n points connected by m segments (they might cross in any way, that doesn't matter). No two segments connect the same pair of points, and no segment connects the point to itself. Masha wants to color some segments in order paint a hedgehog. In Mashas mind every hedgehog consists of a tail and some spines. She wants to paint the tail that satisfies the following conditions:
Only segments already presented on the picture can be painted;
The tail should be continuous, i.e. consists of some sequence of points, such that every two neighbouring points are connected by a colored segment;
The numbers of points from the beginning of the tail to the end should strictly increase.
Masha defines the length of the tail as the number of points in it. Also, she wants to paint some spines. To do so, Masha will paint all the segments, such that one of their ends is the endpoint of the tail. Masha defines the beauty of a hedgehog as the length of the tail multiplied by the number of spines. Masha wants to color the most beautiful hedgehog. Help her calculate what result she may hope to get.
Note that according to Masha's definition of a hedgehog, one segment may simultaneously serve as a spine and a part of the tail (she is a little girl after all). Take a look at the picture for further clarifications.
Input
First line of the input contains two integers n and m(2 ≤ n ≤ 100 000, 1 ≤ m ≤ 200 000) — the number of points and the number segments on the picture respectively.
Then follow m lines, each containing two integers ui and vi (1 ≤ ui, vi ≤ n, ui ≠ vi) — the numbers of points connected by corresponding segment. It's guaranteed that no two segments connect the same pair of points.
Output
Print the maximum possible value of the hedgehog's beauty.
Example
Input
8 64 53 52 51 22 86 7
Output
9
Input
4 61 21 31 42 32 43 4
Output
12
Note
The picture below corresponds to the first sample. Segments that form the hedgehog are painted red. The tail consists of a sequence of points with numbers 1, 2 and 5. The following segments are spines: (2, 5), (3, 5) and (4, 5). Therefore, the beauty of the hedgehog is equal to 3·3 = 9.
题意:有一个图,你把它看成一个刺猬,刺猬有一个尾巴,尾巴满足的条件是从尾巴起始结点到尾巴终止结点是递增的,刺猬还有刺,刺满足的条件是刺有一个长度并与尾巴终止结点相连,求尾巴长度与刺个数乘积的最大值
解法:刺猬的每个结点都可以看作尾巴的终点,且此结点的度即为尾巴的长度,所以要求每个结点作为尾巴终点时尾巴的长,dfs即可
代码:
#include<iostream>
#include<vector>
using namespace std;
int n,m;
vector<int> v[100005];
long long degree[100005];
long long dp[100005];
bool vis[100005];
void dfs(int a)
{
vis[a]=1;
for(int i=0;i<v[a].size();i++){
if(v[a][i]<a){
if(!vis[v[a][i]])
dfs(v[a][i]);
dp[a]=max(dp[a],dp[v[a][i]]+1);
}
}
}
int main()
{
int x,y;
cin>>n>>m;
for(int i=1;i<=n;i++)
dp[i]=1;
for(int i=0;i<m;i++){
cin>>x>>y;
v[x].push_back(y);
v[y].push_back(x);
degree[x]++;
degree[y]++;
}
for(int i=1;i<=n;i++)
if(!vis[i])
dfs(i);
long long ans=0;
for(int i=1;i<=n;i++)
if(dp[i]*degree[i]>ans)
ans=dp[i]*degree[i];
cout<<ans<<endl;
return 0;
}